define {float*, i64} @laplacian(float* in %I, i64 %sizeI, float* in %B, i64 %sizeB, i32 %dimX, i32 %dimY) {
  ; Create dataflow nodes in child graph
  %erode_node = call i8* @llvm.visc.createNode(@erode)
  %dilate_node = call i8* @llvm.visc.createNode(@dilate)
  %lincomb_node = call i8* @llvm.visc.createNode2D(@lincomb, i32 %dimX, i32 %dimY)
  ; Bind inputs of parent node Laplacian with child nodes Dilate, Erode and lincomb
  call void @llvm.visc.bind.input(i8* %dilate_node, i32 0, i32 0)
  call void @llvm.visc.bind.input(i8* %dilate_node, i32 1, i32 1)
  call void @llvm.visc.bind.input(i8* %dilate_node, i32 2, i32 2)
  call void @llvm.visc.bind.input(i8* %dilate_node, i32 3, i32 3)
  call void @llvm.visc.bind.input(i8* %erode_node, i32 0, i32 0)
  call void @llvm.visc.bind.input(i8* %erode_node, i32 1, i32 1)
  call void @llvm.visc.bind.input(i8* %erode_node, i32 2, i32 2)
  call void @llvm.visc.bind.input(i8* %erode_node, i32 3, i32 3)
  call void @llvm.visc.bind.input(i8* %lincomb_node, i32 0, i32 0)
  call void @llvm.visc.bind.input(i8* %lincomb_node, i32 1, i32 1)
  call void @llvm.visc.bind.input(i8* %lincomb_node, i32 2, i32 6)
  call void @llvm.visc.bind.input(i8* %lincomb_node, i32 3, i32 7)
  ; Create edges between child nodes for sending output of Erode and Dilate to lincomb node
  call void @llvm.visc.createEdge(i8* %dilate_node, i8* %lincomb_node, i32 0, i32 2)
  call void @llvm.visc.createEdge(i8* %dilate_node, i8* %lincomb_node, i32 1, i32 3)
  call void @llvm.visc.createEdge(i8* %erode_node, i8* %lincomb_node, i32 0, i32 4)
  call void @llvm.visc.createEdge(i8* %erode_node, i8* %lincomb_node, i32 1, i32 5)
  ; Bind output of lincomb node with output of parent node Laplacian
  call void @llvm.visc.bind.output(i8* %lincomb_node, i32 0, i32 0)
  call void @llvm.visc.bind.output(i8* %lincomb_node, i32 1, i32 1)
  ret {float*, i64} zeroinitializer
}

