#ifndef _PIPE_STAGES_H_
#define _PIPE_STAGES_H_

#include "defs.h"

#define CHAN_SIZE 3

#define ISP 0x4

#define max(a,b) \
  ({ __typeof__ (a) _a = (a); \
      __typeof__ (b) _b = (b); \
    _a > _b ? _a : _b; })

#define min(a,b) \
  ({ __typeof__ (a) _a = (a); \
      __typeof__ (b) _b = (b); \
    _a < _b ? _a : _b; })

#define abs(a) \
  ({ __typeof__ (a) _a = (a); \
    _a < 0 ? -_a : _a; })

extern int num_ctrl_pts;

void scale_fxp(uint8_t *input, size_t bytes_input, 
               float *output, size_t bytes_output,
               int row_size, int col_size);

void descale_fxp(float *input, size_t bytes_input, 
                 uint8_t *output, size_t bytes_result,
                 int row_size, int col_size);

void demosaic_fxp(float *input, size_t bytes_input, 
                  float *result, size_t bytes_result,
                  int row_size, int col_size);

void denoise_fxp(float *input, size_t bytes_input, 
                 float *result, size_t bytes_result,
                 int row_size, int col_size);

void transform_fxp(float *input, size_t bytes_input, 
                   float *result, size_t bytes_result,
                   float *TsTw_tran, size_t bytes_TsTw,
                   int row_size, int col_size);

void gamut_map_fxp(float *input, size_t bytes_input, 
                   float *result, size_t bytes_result,
                   float *ctrl_pts, size_t bytes_ctrl_pts,
                   float *weights, size_t bytes_weights,
                   float *coefs, size_t bytes_coefs,
                   float *l2_dist, size_t bytes_l2_dist,
                   int row_size, int col_size);

void tone_map_fxp(float *input, size_t bytes_input, 
                  float *result, size_t bytes_result,
                  float *tone_map, size_t bytes_tone_map,
                  int row_size, int col_size);

void tone_map_approx_fxp(float *input, int row_size, int col_size,
                         float *result);

#endif
