/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

#include "common.h"

#define MIN(a,b) ((a) <= (b) ? (a) : (b))

__kernel void naive_kernel(float c0,float c1,__global float* A0,__global float *Anext,int nx,int ny,int nz)
{
	int i = get_local_id(0) + TCF * get_local_size(0) * get_group_id(0) + 1;
	int j = get_global_id(1)+1;
	int k = get_global_id(2)+1;

	int limit = MIN(i + TCF * get_local_size(0), nx-1);

	for (int tc = 0; tc < TCF; tc++) {
		if(i < limit)
		{
			Anext[Index3D (nx, ny, i, j, k)] = c1 *
			( A0[Index3D (nx, ny, i, j, k + 1)] +
			  A0[Index3D (nx, ny, i, j, k - 1)] +
			  A0[Index3D (nx, ny, i, j + 1, k)] +
			  A0[Index3D (nx, ny, i, j - 1, k)] +
		 	  A0[Index3D (nx, ny, i + 1, j, k)] +
			  A0[Index3D (nx, ny, i - 1, j, k)] )
			- A0[Index3D (nx, ny, i, j, k)] * c0;
		}
		i += get_local_size(0);
	}

}
