/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

#include "common.h"

#define vloadn vload4
#define vstoren vstore4
#define floatn float4

__kernel void naive_kernel(float c0,float c1,__global float* A0,__global float *Anext,int nx,int ny,int nz)
{
	int i = get_global_id(0)*TCF+1;
	int j = get_global_id(1)+1;
	int k = get_global_id(2)+1;

/*
	int vid = 0;

	if(i+3<nx-1)
	{
	    for (vid = i; vid < i+4; vid++)
		Anext[Index3D (nx, ny, vid, j, k)] = c1 *
		( A0[Index3D (nx, ny, vid, j, k + 1)] +
		  A0[Index3D (nx, ny, vid, j, k - 1)] +
		  A0[Index3D (nx, ny, vid, j + 1, k)] +
		  A0[Index3D (nx, ny, vid, j - 1, k)] +
	 	  A0[Index3D (nx, ny, vid + 1, j, k)] +
		  A0[Index3D (nx, ny, vid - 1, j, k)] )
		- A0[Index3D (nx, ny, vid, j, k)] * c0;
	} else if(i<nx-1)
	{
	    for (vid = i; vid < nx-1 ; vid++)
		Anext[Index3D (nx, ny, vid, j, k)] = c1 *
		( A0[Index3D (nx, ny, vid, j, k + 1)] +
		  A0[Index3D (nx, ny, vid, j, k - 1)] +
		  A0[Index3D (nx, ny, vid, j + 1, k)] +
		  A0[Index3D (nx, ny, vid, j - 1, k)] +
	 	  A0[Index3D (nx, ny, vid + 1, j, k)] +
		  A0[Index3D (nx, ny, vid - 1, j, k)] )
		- A0[Index3D (nx, ny, vid, j, k)] * c0;
	}
*/

	floatn current, top, bottom, up, down, left, right;
	float left_el, right_el;

	if(i+TCF-1 < nx-1)
	{
		current	= vloadn(0, A0 + Index3D (nx, ny, i, j, k));
		top	= vloadn(0, A0 + Index3D (nx, ny, i, j, k+1));
		bottom	= vloadn(0, A0 + Index3D (nx, ny, i, j, k-1));
		up	= vloadn(0, A0 + Index3D (nx, ny, i, j+1, k));
		down	= vloadn(0, A0 + Index3D (nx, ny, i, j-1, k));
		right_el = A0[Index3D (nx, ny, i+1, j, k)];
		left_el = A0[Index3D (nx, ny, i-1, j, k)];
		//TODO: change these too if changing vector length
		right = (floatn)(current.yzw, right_el);
		left = (floatn)(left_el, current.xyz);
		current = c1 * (top + bottom + up + down + right + left)
			 - current * c0;
		vstoren(current, 0, Anext + Index3D (nx, ny, i, j, k));
	} else if(i<nx-1)
	{
	    for (int vid = i; vid < nx-1 ; vid++)
		Anext[Index3D (nx, ny, vid, j, k)] = c1 *
		( A0[Index3D (nx, ny, vid, j, k + 1)] +
		  A0[Index3D (nx, ny, vid, j, k - 1)] +
		  A0[Index3D (nx, ny, vid, j + 1, k)] +
		  A0[Index3D (nx, ny, vid, j - 1, k)] +
	 	  A0[Index3D (nx, ny, vid + 1, j, k)] +
		  A0[Index3D (nx, ny, vid - 1, j, k)] )
		- A0[Index3D (nx, ny, vid, j, k)] * c0;
	}

}
