; RUN: opt -load LLVMBuildDFG.so -load LLVMDFG2LLVM_NVPTX.so -load LLVMDFG2LLVM_X86.so -load LLVMClearDFG.so -dfg2llvm-nvptx -dfg2llvm-x86 -clearDFG -o %t.ll -S %s
; RUN: llvm-link %llvm_src/../libclc/built_libs/nvptx--nvidiacl.bc %s.kernels.ll -o %t.ll.kernels.linked.bc
; RUN: clang -O3 -target nvptx %t.ll.kernels.linked.bc -S -o %s.nvptx.s
; RUN: llvm-link %t.ll %llvm_src/projects/visc-rt/visc-rt.ll parboil.ll  -S -o %t.linked.ll
; RUN: clang++ -O3 %t.linked.ll -lpthread -lOpenCL -o %t.bin
; ModuleID = 'build/visc_vec_default/stencil.ll'
target datalayout = "e-p:64:64:64-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:64:64-f32:32:32-f64:64:64-v64:64:64-v128:128:128-a0:0:64-s0:64:64-f80:128:128-n8:16:32:64-S128"
target triple = "x86_64-unknown-linux-gnu"

%rtype = type {}
%struct.pb_TimerSet = type { i32, %struct.pb_async_time_marker_list*, i64, i64, [24 x %struct.pb_Timer], [24 x %struct.pb_SubTimerList*] }
%struct.pb_async_time_marker_list = type { i8*, i32, i8*, %struct.pb_async_time_marker_list* }
%struct.pb_Timer = type { i32, i64, i64 }
%struct.pb_SubTimerList = type { %struct.pb_SubTimer*, %struct.pb_SubTimer* }
%struct.pb_SubTimer = type { i8*, %struct.pb_Timer, %struct.pb_SubTimer* }
%struct.pb_Parameters = type { i8*, i8** }
%struct._IO_FILE = type { i32, i8*, i8*, i8*, i8*, i8*, i8*, i8*, i8*, i8*, i8*, i8*, %struct._IO_marker*, %struct._IO_FILE*, i32, i32, i64, i16, i8, [1 x i8], i8*, i64, i8*, i8*, i8*, i8*, i64, i32, [20 x i8] }
%struct._IO_marker = type { %struct._IO_marker*, %struct._IO_FILE*, i32 }
%struct.arg = type <{ float, float, float*, i64, float*, i64, i32, i32, i32, i32, i32, i32, i32, i32, i32, %rtype }>

@.str3 = private unnamed_addr constant [3 x i8] c"rb\00", align 1
@.str4 = private unnamed_addr constant [37 x i8] c"grid(%d, %d, %d), block(%d, %d, %d)\0A\00", align 1
@.str5 = private unnamed_addr constant [17 x i8] c"A[126,1,1] = %f\0A\00", align 1
@.str6 = private unnamed_addr constant [17 x i8] c"A[125,1,1] = %f\0A\00", align 1
@str = private unnamed_addr constant [46 x i8] c"OpenCL accelerated 7 points stencil codes****\00"
@str7 = private unnamed_addr constant [45 x i8] c"Author: Li-Wen Chang <lchang20@illinois.edu>\00"
@str8 = private unnamed_addr constant [106 x i8] c"Usage: probe nx ny nz t\0Anx: the grid size x\0Any: the grid size y\0Anz: the grid size z\0At: the iteration time\00"
@viscTimerSet_GenVISC = common global i8* null
@0 = internal constant [14 x i8] c"GenVISC_Timer\00"

; Function Attrs: nounwind uwtable
define %rtype @naive_kernel(float %c0, float %c1, float* in %A0, i64 %bytes_A0, float* in out %Anext, i64 %bytes_Anext, i32 %nx, i32 %ny, i32 %nz) #0 {
entry:
  %naive_kernel.node = call i8* @llvm.visc.getNode()
  %naive_kernel.parentNode = call i8* @llvm.visc.getParentNode(i8* %naive_kernel.node)
  %a0 = call i32 @llvm.visc.getNodeInstanceID.x(i8* %naive_kernel.parentNode)
  %a1 = call i32 @llvm.visc.getNumNodeInstances.x(i8* %naive_kernel.node)
  %a2 = mul i32 %a0, %a1
  %a3 = call i32 @llvm.visc.getNodeInstanceID.x(i8* %naive_kernel.node)
  %a4 = add i32 %a2, %a3
  ;%add = add nsw i32 %4, 1
  %a5 = call i32 @llvm.visc.getNodeInstanceID.y(i8* %naive_kernel.parentNode)
  %a6 = call i32 @llvm.visc.getNumNodeInstances.y(i8* %naive_kernel.node)
  %a7 = mul i32 %a5, %a6
  %a8 = call i32 @llvm.visc.getNodeInstanceID.y(i8* %naive_kernel.node)
  %a9 = add i32 %a7, %a8
  ;%add3 = add nsw i32 %9, 1
  %a10 = call i32 @llvm.visc.getNodeInstanceID.z(i8* %naive_kernel.parentNode)
  %a11 = call i32 @llvm.visc.getNumNodeInstances.z(i8* %naive_kernel.node)
  %a12 = mul i32 %a10, %a11
  %a13 = call i32 @llvm.visc.getNodeInstanceID.z(i8* %naive_kernel.node)
  %a14 = add i32 %a12, %a13
  ;%sub = add nsw i32 %nx, -1
  ;%cmp = icmp slt i32 %add, %sub
  ;br i1 %cmp, label %if.then, label %if.end


  ;%call = tail call i32 @get_global_id(i32 0) #2
  ;%mul = shl i32 %call, 2
  %mul = shl i32 %a4, 2
  %add258 = or i32 %mul, 1
  ;%call1 = tail call i32 @get_global_id(i32 1) #2
  ;%add2 = add i32 %call1, 1
  %add2 = add i32 %a9, 1
  ;%call3 = tail call i32 @get_global_id(i32 2) #2
  ;%add4 = add i32 %call3, 1
  %add4 = add i32 %a14, 1
  %sub = add i32 %add258, 3
  %sub6 = add i32 %nx, -1
  %cmp = icmp slt i32 %sub, %sub6
  br i1 %cmp, label %if.then, label %if.else

if.then:                                          ; preds = %entry
  %mul7 = mul nsw i32 %add4, %ny
  %add8 = add nsw i32 %mul7, %add2
  %mul9 = mul nsw i32 %add8, %nx
  %add11 = add i32 %sub, %mul9
  %add.ptr = getelementptr inbounds float* %A0, i32 %add11
  ;%call12 = tail call <4 x float> @_Z6vload4jPKU3AS1f(i32 0, float* %add.ptr) #2
  %vadd.ptr = bitcast float* %add.ptr to <4 x float>*
  %call12 = load <4 x float>* %vadd.ptr

  %add13 = add i32 %a14, 2
  %mul14 = mul nsw i32 %add13, %ny
  %add15 = add nsw i32 %mul14, %add2
  %mul16 = mul nsw i32 %add15, %nx
  %add18 = add i32 %sub, %mul16
  %add.ptr19 = getelementptr inbounds float* %A0, i32 %add18
  ;%call20 = tail call <4 x float> @_Z6vload4jPKU3AS1f(i32 0, float* %add.ptr19) #2
  %vadd.ptr19 = bitcast float* %add.ptr19 to <4 x float>*
  %call20 = load <4 x float>* %vadd.ptr19

  %mul22 = mul nsw i32 %a14, %ny
  %add23 = add nsw i32 %mul22, %add2
  %mul24 = mul nsw i32 %add23, %nx
  %add26 = add i32 %sub, %mul24
  %add.ptr27 = getelementptr inbounds float* %A0, i32 %add26
  ;%call28 = tail call <4 x float> @_Z6vload4jPKU3AS1f(i32 0, float* %add.ptr27) #2
  %vadd.ptr27 = bitcast float* %add.ptr27 to <4 x float>*
  %call28 = load <4 x float>* %vadd.ptr27

  %add29 = add i32 %a9, 2
  %add31 = add nsw i32 %add29, %mul7
  %mul32 = mul nsw i32 %add31, %nx
  %add34 = add i32 %sub, %mul32
  %add.ptr35 = getelementptr inbounds float* %A0, i32 %add34
  ;%call36 = tail call <4 x float> @_Z6vload4jPKU3AS1f(i32 0, float* %add.ptr35) #2
  %vadd.ptr35 = bitcast float* %add.ptr35 to <4 x float>*
  %call36 = load <4 x float>* %vadd.ptr35

  %add39 = add nsw i32 %mul7, %a9
  %mul40 = mul nsw i32 %add39, %nx
  %add42 = add i32 %sub, %mul40
  %add.ptr43 = getelementptr inbounds float* %A0, i32 %add42
  ;%call44 = tail call <4 x float> @_Z6vload4jPKU3AS1f(i32 0, float* %add.ptr43) #2
  %vadd.ptr43 = bitcast float* %add.ptr43 to <4 x float>*
  %call44 = load <4 x float>* %vadd.ptr43

  %add49 = add i32 %add258, 4
  %add50 = add i32 %add49, %mul9
  %arrayidx = getelementptr inbounds float* %A0, i32 %add50
  %0 = load float* %arrayidx, align 4, !tbaa !2
  %add55261 = or i32 %mul, 3
  %add56 = add i32 %add55261, %mul9
  %arrayidx57 = getelementptr inbounds float* %A0, i32 %add56
  %1 = load float* %arrayidx57, align 4, !tbaa !2
  %2 = shufflevector <4 x float> %call12, <4 x float> undef, <3 x i32> <i32 1, i32 2, i32 3>
  %vext = shufflevector <3 x float> %2, <3 x float> undef, <4 x i32> <i32 0, i32 1, i32 2, i32 undef>
  %vecinit58 = insertelement <4 x float> %vext, float %0, i32 3
  %vecinit60 = insertelement <4 x float> undef, float %1, i32 0
  %vecinit62 = shufflevector <4 x float> %vecinit60, <4 x float> %call12, <4 x i32> <i32 0, i32 4, i32 5, i32 6>
  %splat.splatinsert = insertelement <4 x float> undef, float %c1, i32 0
  %splat.splat = shufflevector <4 x float> %splat.splatinsert, <4 x float> undef, <4 x i32> zeroinitializer
  %add63 = fadd fast <4 x float> %call20, %call28
  %add64 = fadd fast <4 x float> %add63, %call36
  %add65 = fadd fast <4 x float> %add64, %call44
  %add66 = fadd fast <4 x float> %add65, %vecinit58
  %add67 = fadd fast <4 x float> %add66, %vecinit62
  %mul68 = fmul fast <4 x float> %splat.splat, %add67
  %splat.splatinsert69 = insertelement <4 x float> undef, float %c0, i32 0
  %splat.splat70 = shufflevector <4 x float> %splat.splatinsert69, <4 x float> undef, <4 x i32> zeroinitializer
  %mul71 = fmul fast <4 x float> %splat.splat70, %call12
  %sub72 = fsub fast <4 x float> %mul68, %mul71
  %add.ptr78 = getelementptr inbounds float* %Anext, i32 %add11
  ;tail call void @_Z7vstore4Dv4_fjPU3AS1f(<4 x float> %sub72, i32 0, float* %add.ptr78) #2
  %vadd.ptr78 = bitcast float* %add.ptr78 to <4 x float>*
  store <4 x float> %sub72, <4 x float>* %vadd.ptr78

  br label %if.end146

if.else:                                          ; preds = %entry
  %cmp80 = icmp slt i32 %add258, %sub6
  br i1 %cmp80, label %for.body.lr.ph, label %if.end146

for.body.lr.ph:                                   ; preds = %if.else
  %add84 = add i32 %a14, 2
  %mul85 = mul nsw i32 %add84, %ny
  %add86 = add nsw i32 %mul85, %add2
  %mul87 = mul nsw i32 %add86, %nx
  %add88 = add i32 %mul87, 3
  %mul92 = mul nsw i32 %a14, %ny
  %add93 = add nsw i32 %mul92, %add2
  %mul94 = mul nsw i32 %add93, %nx
  %add95 = add i32 %mul94, 3
  %add99 = add i32 %a9, 2
  %mul100 = mul nsw i32 %add4, %ny
  %add101 = add nsw i32 %add99, %mul100
  %mul102 = mul nsw i32 %add101, %nx
  %add103 = add i32 %mul102, 3
  %add109 = add nsw i32 %mul100, %a9
  %mul110 = mul nsw i32 %add109, %nx
  %add111 = add i32 %mul110, 3
  %add117 = add nsw i32 %mul100, %add2
  %mul118 = mul nsw i32 %add117, %nx
  %add119 = add i32 %mul118, 3
  %add127 = add i32 %mul118, 2
  br label %for.body

for.body:                                         ; preds = %for.body, %for.body.lr.ph
  %vid.0260 = phi i32 [ %add258, %for.body.lr.ph ], [ %add115, %for.body ]
  %add89 = add i32 %add88, %vid.0260
  %arrayidx90 = getelementptr inbounds float* %A0, i32 %add89
  %3 = load float* %arrayidx90, align 4, !tbaa !2
  %add96 = add i32 %add95, %vid.0260
  %arrayidx97 = getelementptr inbounds float* %A0, i32 %add96
  %4 = load float* %arrayidx97, align 4, !tbaa !2
  %add98 = fadd fast float %3, %4
  %add104 = add i32 %add103, %vid.0260
  %arrayidx105 = getelementptr inbounds float* %A0, i32 %add104
  %5 = load float* %arrayidx105, align 4, !tbaa !2
  %add106 = fadd fast float %add98, %5
  %add112 = add i32 %add111, %vid.0260
  %arrayidx113 = getelementptr inbounds float* %A0, i32 %add112
  %6 = load float* %arrayidx113, align 4, !tbaa !2
  %add114 = fadd fast float %add106, %6
  %add115 = add nsw i32 %vid.0260, 1
  %add120 = add i32 %add119, %add115
  %arrayidx121 = getelementptr inbounds float* %A0, i32 %add120
  %7 = load float* %arrayidx121, align 4, !tbaa !2
  %add122 = fadd fast float %add114, %7
  %add128 = add i32 %add127, %vid.0260
  %arrayidx129 = getelementptr inbounds float* %A0, i32 %add128
  %8 = load float* %arrayidx129, align 4, !tbaa !2
  %add130 = fadd fast float %add122, %8
  %mul131 = fmul fast float %add130, %c1
  %add136 = add i32 %add119, %vid.0260
  %arrayidx137 = getelementptr inbounds float* %A0, i32 %add136
  %9 = load float* %arrayidx137, align 4, !tbaa !2
  %mul138 = fmul fast float %9, %c0
  %sub139 = fsub fast float %mul131, %mul138
  %arrayidx145 = getelementptr inbounds float* %Anext, i32 %add136
  store float %sub139, float* %arrayidx145, align 4, !tbaa !2
  %exitcond = icmp eq i32 %add115, %sub6
  br i1 %exitcond, label %if.end146, label %for.body

if.end146:                                        ; preds = %for.body, %if.else, %if.then
  ;ret void





;if.then:                                          ; preds = %entry
  ;%add5 = add nsw i32 %14, 1
  ;%add6 = add nsw i32 %14, 2
  ;%mul = mul nsw i32 %add6, %ny
  ;%add7 = add nsw i32 %mul, %add3
  ;%mul8 = mul nsw i32 %add7, %nx
  ;%add9 = add i32 %4, 4
  ;%add10 = add i32 %add9, %mul8
  ;%idxprom = sext i32 %add10 to i64
  ;%arrayidx = getelementptr inbounds float* %A0, i64 %idxprom
  ;%15 = load float* %arrayidx, align 4, !tbaa !2
  ;%mul12 = mul nsw i32 %14, %ny
  ;%add13 = add nsw i32 %mul12, %add3
  ;%mul14 = mul nsw i32 %add13, %nx
  ;%add16 = add i32 %add9, %mul14
  ;%idxprom17 = sext i32 %add16 to i64
  ;%arrayidx18 = getelementptr inbounds float* %A0, i64 %idxprom17
  ;%16 = load float* %arrayidx18, align 4, !tbaa !2
  ;%add19 = fadd fast float %15, %16
  ;%add20 = add nsw i32 %9, 2
  ;%mul21 = mul nsw i32 %add5, %ny
  ;%add22 = add nsw i32 %add20, %mul21
  ;%mul23 = mul nsw i32 %add22, %nx
  ;%add25 = add i32 %add9, %mul23
  ;%idxprom26 = sext i32 %add25 to i64
  ;%arrayidx27 = getelementptr inbounds float* %A0, i64 %idxprom26
  ;%17 = load float* %arrayidx27, align 4, !tbaa !2
  ;%add28 = fadd fast float %add19, %17
  ;%add31 = add nsw i32 %mul21, %9
  ;%mul32 = mul nsw i32 %add31, %nx
  ;%add34 = add i32 %add9, %mul32
  ;%idxprom35 = sext i32 %add34 to i64
  ;%arrayidx36 = getelementptr inbounds float* %A0, i64 %idxprom35
  ;%18 = load float* %arrayidx36, align 4, !tbaa !2
  ;%add37 = fadd fast float %add28, %18
  ;%add40 = add nsw i32 %mul21, %add3
  ;%mul41 = mul nsw i32 %add40, %nx
  ;%add42 = add i32 %4, 5
  ;%add43 = add i32 %add42, %mul41
  ;%idxprom44 = sext i32 %add43 to i64
  ;%arrayidx45 = getelementptr inbounds float* %A0, i64 %idxprom44
  ;%19 = load float* %arrayidx45, align 4, !tbaa !2
  ;%add46 = fadd fast float %add37, %19
  ;%add51 = add i32 %4, 3
  ;%add52 = add i32 %add51, %mul41
  ;%idxprom53 = sext i32 %add52 to i64
  ;%arrayidx54 = getelementptr inbounds float* %A0, i64 %idxprom53
  ;%20 = load float* %arrayidx54, align 4, !tbaa !2
  ;%add55 = fadd fast float %add46, %20
  ;%mul56 = fmul fast float %add55, %c1
  ;%add61 = add i32 %add9, %mul41
  ;%idxprom62 = sext i32 %add61 to i64
  ;%arrayidx63 = getelementptr inbounds float* %A0, i64 %idxprom62
  ;%21 = load float* %arrayidx63, align 4, !tbaa !2
  ;%mul64 = fmul fast float %21, %c0
  ;%sub65 = fsub fast float %mul56, %mul64
  ;%arrayidx72 = getelementptr inbounds float* %Anext, i64 %idxprom62
  ;store float %sub65, float* %arrayidx72, align 4, !tbaa !2
  ;br label %if.end

;if.end:                                           ; preds = %if.then, %entry
  ret %rtype undef
}

; Function Attrs: nounwind uwtable
define i32 @main(i32 %argc, i8** %argv) #0 {
entry:
  %argc.addr = alloca i32, align 4
  %timers = alloca %struct.pb_TimerSet, align 8
  store i32 %argc, i32* %argc.addr, align 4, !tbaa !5
  %0 = bitcast %struct.pb_TimerSet* %timers to i8*
  call void @llvm.lifetime.start(i64 800, i8* %0) #1
  %puts = call i32 @puts(i8* getelementptr inbounds ([46 x i8]* @str, i64 0, i64 0))
  %puts186 = call i32 @puts(i8* getelementptr inbounds ([45 x i8]* @str7, i64 0, i64 0))
  %call2 = call %struct.pb_Parameters* @pb_ReadParameters(i32* %argc.addr, i8** %argv) #1
  %1 = load i32* %argc.addr, align 4, !tbaa !5
  %cmp = icmp slt i32 %1, 5
  br i1 %cmp, label %if.then, label %if.end

if.then:                                          ; preds = %entry
  %puts187 = call i32 @puts(i8* getelementptr inbounds ([106 x i8]* @str8, i64 0, i64 0))
  br label %cleanup

if.end:                                           ; preds = %entry
  %arrayidx = getelementptr inbounds i8** %argv, i64 1
  %2 = load i8** %arrayidx, align 8, !tbaa !6
  %call.i = call i64 @strtol(i8* nocapture %2, i8** null, i32 10) #1
  %conv.i = trunc i64 %call.i to i32
  %cmp5 = icmp slt i32 %conv.i, 1
  br i1 %cmp5, label %cleanup, label %if.end7

if.end7:                                          ; preds = %if.end
  %arrayidx8 = getelementptr inbounds i8** %argv, i64 2
  %3 = load i8** %arrayidx8, align 8, !tbaa !6
  %call.i188 = call i64 @strtol(i8* nocapture %3, i8** null, i32 10) #1
  %conv.i189 = trunc i64 %call.i188 to i32
  %cmp10 = icmp slt i32 %conv.i189, 1
  br i1 %cmp10, label %cleanup, label %if.end12

if.end12:                                         ; preds = %if.end7
  %arrayidx13 = getelementptr inbounds i8** %argv, i64 3
  %4 = load i8** %arrayidx13, align 8, !tbaa !6
  %call.i190 = call i64 @strtol(i8* nocapture %4, i8** null, i32 10) #1
  %conv.i191 = trunc i64 %call.i190 to i32
  %cmp15 = icmp slt i32 %conv.i191, 1
  br i1 %cmp15, label %cleanup, label %if.end17

if.end17:                                         ; preds = %if.end12
  %arrayidx18 = getelementptr inbounds i8** %argv, i64 4
  %5 = load i8** %arrayidx18, align 8, !tbaa !6
  %call.i192 = call i64 @strtol(i8* nocapture %5, i8** null, i32 10) #1
  %conv.i193 = trunc i64 %call.i192 to i32
  %cmp20 = icmp slt i32 %conv.i193, 1
  br i1 %cmp20, label %cleanup, label %for.cond1.preheader.lr.ph.i

for.cond1.preheader.lr.ph.i:                      ; preds = %if.end17
  %mul = shl i64 %call.i, 32
  %mul23 = mul i64 %mul, %call.i188
  %sext = mul i64 %mul23, %call.i190
  %add = ashr exact i64 %sext, 30
  %mul24 = add i64 %add, 12
  %call25 = call noalias i8* @malloc(i64 %mul24) #1
  %6 = bitcast i8* %call25 to float*
  %call27 = call noalias i8* @malloc(i64 %mul24) #1
  %7 = bitcast i8* %call27 to float*
  %inpFiles = getelementptr inbounds %struct.pb_Parameters* %call2, i64 0, i32 1
  %8 = load i8*** %inpFiles, align 8, !tbaa !6
  %9 = load i8** %8, align 8, !tbaa !6
  %call29 = call %struct._IO_FILE* @fopen(i8* %9, i8* getelementptr inbounds ([3 x i8]* @.str3, i64 0, i64 0)) #1
  %add.ptr = getelementptr inbounds i8* %call25, i64 12
  %10 = bitcast i8* %add.ptr to float*
  %cmp24.i = icmp sgt i32 %conv.i189, 0
  %cmp51.i = icmp sgt i32 %conv.i, 0
  %or.cond = and i1 %cmp24.i, %cmp51.i
  br i1 %or.cond, label %for.cond4.preheader.lr.ph.us.i.preheader.split.us, label %read_data.exit

for.cond4.preheader.lr.ph.us.i.preheader.split.us: ; preds = %for.cond1.preheader.lr.ph.i
  %11 = mul i32 %conv.i, %conv.i189
  br label %for.body6.lr.ph.us.us.i.preheader.us

for.body6.lr.ph.us.us.i.us:                       ; preds = %for.body6.lr.ph.us.us.i.preheader.us, %for.inc8.us.us.i.us
  %j.06.us.us.i.us = phi i32 [ %inc9.us.us.i.us, %for.inc8.us.us.i.us ], [ 0, %for.body6.lr.ph.us.us.i.preheader.us ]
  %s.15.us.us.i.us = phi i32 [ %14, %for.inc8.us.us.i.us ], [ %s.09.us.i.us, %for.body6.lr.ph.us.us.i.preheader.us ]
  %12 = sext i32 %s.15.us.us.i.us to i64
  br label %for.body6.us.us.i.us

for.body6.us.us.i.us:                             ; preds = %for.body6.us.us.i.us, %for.body6.lr.ph.us.us.i.us
  %indvars.iv.i.us = phi i64 [ %indvars.iv.next.i.us, %for.body6.us.us.i.us ], [ %12, %for.body6.lr.ph.us.us.i.us ]
  %k.03.us.us.i.us = phi i32 [ %inc7.us.us.i.us, %for.body6.us.us.i.us ], [ 0, %for.body6.lr.ph.us.us.i.us ]
  %add.ptr.us.us.i.us = getelementptr inbounds float* %10, i64 %indvars.iv.i.us
  %13 = bitcast float* %add.ptr.us.us.i.us to i8*
  %call.us.us.i.us = call i64 @fread(i8* %13, i64 4, i64 1, %struct._IO_FILE* %call29) #1
  %indvars.iv.next.i.us = add i64 %indvars.iv.i.us, 1
  %inc7.us.us.i.us = add nsw i32 %k.03.us.us.i.us, 1
  %exitcond.i.us = icmp eq i32 %inc7.us.us.i.us, %conv.i
  br i1 %exitcond.i.us, label %for.inc8.us.us.i.us, label %for.body6.us.us.i.us

for.inc8.us.us.i.us:                              ; preds = %for.body6.us.us.i.us
  %14 = add i32 %s.15.us.us.i.us, %conv.i
  %inc9.us.us.i.us = add nsw i32 %j.06.us.us.i.us, 1
  %exitcond33.i.us = icmp eq i32 %inc9.us.us.i.us, %conv.i189
  br i1 %exitcond33.i.us, label %for.inc11.us.i.us, label %for.body6.lr.ph.us.us.i.us

for.inc11.us.i.us:                                ; preds = %for.inc8.us.us.i.us
  %15 = add i32 %11, %s.09.us.i.us
  %inc12.us.i.us = add nsw i32 %i.010.us.i.us, 1
  %exitcond34.i.us = icmp eq i32 %inc12.us.i.us, %conv.i191
  br i1 %exitcond34.i.us, label %read_data.exit, label %for.body6.lr.ph.us.us.i.preheader.us

for.body6.lr.ph.us.us.i.preheader.us:             ; preds = %for.inc11.us.i.us, %for.cond4.preheader.lr.ph.us.i.preheader.split.us
  %i.010.us.i.us = phi i32 [ %inc12.us.i.us, %for.inc11.us.i.us ], [ 0, %for.cond4.preheader.lr.ph.us.i.preheader.split.us ]
  %s.09.us.i.us = phi i32 [ %15, %for.inc11.us.i.us ], [ 0, %for.cond4.preheader.lr.ph.us.i.preheader.split.us ]
  br label %for.body6.lr.ph.us.us.i.us

read_data.exit:                                   ; preds = %for.inc11.us.i.us, %for.cond1.preheader.lr.ph.i
  %call31 = call i32 @fclose(%struct._IO_FILE* %call29) #1
  call void @pb_InitializeTimerSet(%struct.pb_TimerSet* %timers) #1
  %16 = call i8* @llvm_visc_initializeTimerSet()
  store i8* %16, i8** @viscTimerSet_GenVISC
  call void @llvm_visc_switchToTimer(i8** @viscTimerSet_GenVISC, i32 0)
  call void @llvm.visc.init()
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 15) #1
  call void @llvm_visc_track_mem(i8* %call25, i64 %mul24) #1
  call void @llvm_visc_track_mem(i8* %call27, i64 %mul24) #1
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 6) #1
  call void @llvm.memcpy.p0i8.p0i8.i64(i8* %call27, i8* %call25, i64 %mul24, i32 4, i1 false)
  %sub40 = add nsw i32 %conv.i, 253
  %div = sdiv i32 %sub40, 256
  %mul42 = shl nsw i32 %div, 6
  %sub44 = add nsw i32 %conv.i189, -2
  %sub46 = add nsw i32 %conv.i191, -2
  %call53 = call i32 (i8*, ...)* @printf(i8* getelementptr inbounds ([37 x i8]* @.str4, i64 0, i64 0), i32 %mul42, i32 %sub44, i32 %sub46, i32 64, i32 1, i32 1) #1
  %add56 = add nsw i32 %conv.i189, 1
  %mul57 = mul nsw i32 %add56, %conv.i
  %add59 = add nsw i32 %mul57, 129
  %idxprom = sext i32 %add59 to i64
  %arrayidx60 = getelementptr inbounds float* %6, i64 %idxprom
  %17 = load float* %arrayidx60, align 4, !tbaa !2
  %conv61 = fpext float %17 to double
  %call62 = call i32 (i8*, ...)* @printf(i8* getelementptr inbounds ([17 x i8]* @.str5, i64 0, i64 0), double %conv61) #1
  %add67 = add nsw i32 %mul57, 128
  %idxprom68 = sext i32 %add67 to i64
  %arrayidx69 = getelementptr inbounds float* %6, i64 %idxprom68
  %18 = load float* %arrayidx69, align 4, !tbaa !2
  %conv70 = fpext float %18 to double
  %call71 = call i32 (i8*, ...)* @printf(i8* getelementptr inbounds ([17 x i8]* @.str6, i64 0, i64 0), double %conv70) #1
  %cmp72194 = icmp sgt i32 %conv.i193, 0
  br i1 %cmp72194, label %for.body, label %for.end

for.body:                                         ; preds = %for.body, %read_data.exit
  %h_A0.0197 = phi float* [ %h_Anext.0196, %for.body ], [ %6, %read_data.exit ]
  %h_Anext.0196 = phi float* [ %h_A0.0197, %for.body ], [ %7, %read_data.exit ]
  %t.0195 = phi i32 [ %inc, %for.body ], [ 0, %read_data.exit ]
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 0) #1
  call void @llvm_visc_switchToTimer(i8** @viscTimerSet_GenVISC, i32 19)
  %in.addr = alloca %struct.arg
  %in.addr.c0 = getelementptr %struct.arg* %in.addr, i32 0, i32 0
  %in.addr.c0.cast = fptrunc double 0x3FC5555560000000 to float
  store float %in.addr.c0.cast, float* %in.addr.c0
  %in.addr.c1 = getelementptr %struct.arg* %in.addr, i32 0, i32 1
  %in.addr.c1.cast = fptrunc double 0x3F9C71C720000000 to float
  store float %in.addr.c1.cast, float* %in.addr.c1
  %in.addr.A0 = getelementptr %struct.arg* %in.addr, i32 0, i32 2
  store float* %h_A0.0197, float** %in.addr.A0
  %in.addr.bytes_A0 = getelementptr %struct.arg* %in.addr, i32 0, i32 3
  store i64 %mul24, i64* %in.addr.bytes_A0
  %in.addr.Anext = getelementptr %struct.arg* %in.addr, i32 0, i32 4
  store float* %h_Anext.0196, float** %in.addr.Anext
  %in.addr.bytes_Anext = getelementptr %struct.arg* %in.addr, i32 0, i32 5
  store i64 %mul24, i64* %in.addr.bytes_Anext
  %in.addr.nx = getelementptr %struct.arg* %in.addr, i32 0, i32 6
  store i32 %conv.i, i32* %in.addr.nx
  %in.addr.ny = getelementptr %struct.arg* %in.addr, i32 0, i32 7
  store i32 %conv.i189, i32* %in.addr.ny
  %in.addr.nz = getelementptr %struct.arg* %in.addr, i32 0, i32 8
  store i32 %conv.i191, i32* %in.addr.nz
  %in.addr.dimX0 = getelementptr %struct.arg* %in.addr, i32 0, i32 9
  store i32 64, i32* %in.addr.dimX0
  %in.addr.dimY0 = getelementptr %struct.arg* %in.addr, i32 0, i32 10
  store i32 1, i32* %in.addr.dimY0
  %in.addr.dimZ1 = getelementptr %struct.arg* %in.addr, i32 0, i32 11
  store i32 1, i32* %in.addr.dimZ1
  %in.addr.dimX1 = getelementptr %struct.arg* %in.addr, i32 0, i32 12
  store i32 %div, i32* %in.addr.dimX1
  %in.addr.dimY2 = getelementptr %struct.arg* %in.addr, i32 0, i32 13
  store i32 %sub44, i32* %in.addr.dimY2
  %in.addr.dimZ2 = getelementptr %struct.arg* %in.addr, i32 0, i32 14
  store i32 %sub46, i32* %in.addr.dimZ2
  %args = bitcast %struct.arg* %in.addr to i8*
  call void @llvm_visc_switchToTimer(i8** @viscTimerSet_GenVISC, i32 0)
  %graphnaive_kernelInternal_level2 = call i8* @llvm.visc.launch(i8* bitcast (%rtype (float, float, float*, i64, float*, i64, i32, i32, i32, i32, i32, i32, i32, i32, i32)* @naive_kernelInternal_level2 to i8*), i8* %args)
  call void @llvm.visc.wait(i8* %graphnaive_kernelInternal_level2)
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 6) #1
  %inc = add nsw i32 %t.0195, 1
  %exitcond = icmp eq i32 %inc, %conv.i193
  br i1 %exitcond, label %for.end, label %for.body

for.end:                                          ; preds = %for.body, %read_data.exit
  %h_A0.0.lcssa = phi float* [ %6, %read_data.exit ], [ %h_Anext.0196, %for.body ]
  %h_Anext.0.lcssa = phi float* [ %7, %read_data.exit ], [ %h_A0.0197, %for.body ]
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 3) #1
  %19 = bitcast float* %h_A0.0.lcssa to i8*
  call void @llvm_visc_request_mem(i8* %19, i64 %mul24) #1
  %arrayidx97 = getelementptr inbounds float* %h_A0.0.lcssa, i64 %idxprom
  %20 = load float* %arrayidx97, align 4, !tbaa !2
  %conv98 = fpext float %20 to double
  %call99 = call i32 (i8*, ...)* @printf(i8* getelementptr inbounds ([17 x i8]* @.str5, i64 0, i64 0), double %conv98) #1
  %arrayidx106 = getelementptr inbounds float* %h_A0.0.lcssa, i64 %idxprom68
  %21 = load float* %arrayidx106, align 4, !tbaa !2
  %conv107 = fpext float %21 to double
  %call108 = call i32 (i8*, ...)* @printf(i8* getelementptr inbounds ([17 x i8]* @.str6, i64 0, i64 0), double %conv107) #1
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 16) #1
  %22 = bitcast float* %h_Anext.0.lcssa to i8*
  call void @llvm_visc_untrack_mem(i8* %22) #1
  call void @llvm_visc_untrack_mem(i8* %19) #1
  call void @pb_SwitchToTimer(%struct.pb_TimerSet* %timers, i32 0) #1
  call void @pb_PrintTimerSet(%struct.pb_TimerSet* %timers) #1
  %Ptr = getelementptr [14 x i8]* @0, i64 0, i64 0
  call void @llvm_visc_printTimerSet(i8** @viscTimerSet_GenVISC, i8* %Ptr)
  call void @llvm.visc.cleanup()
  %outFile = getelementptr inbounds %struct.pb_Parameters* %call2, i64 0, i32 0
  %23 = load i8** %outFile, align 8, !tbaa !6
  %tobool = icmp eq i8* %23, null
  br i1 %tobool, label %if.end113, label %if.then110

if.then110:                                       ; preds = %for.end
  %add.ptr112 = getelementptr inbounds float* %h_A0.0.lcssa, i64 3
  call void @outputData(i8* %23, float* %add.ptr112, i32 %conv.i, i32 %conv.i189, i32 %conv.i191) #1
  br label %if.end113

if.end113:                                        ; preds = %if.then110, %for.end
  call void @free(i8* %22) #1
  call void @free(i8* %19) #1
  call void @pb_FreeParameters(%struct.pb_Parameters* %call2) #1
  br label %cleanup

cleanup:                                          ; preds = %if.end113, %if.end17, %if.end12, %if.end7, %if.end, %if.then
  %retval.0 = phi i32 [ -1, %if.then ], [ 0, %if.end113 ], [ -1, %if.end ], [ -1, %if.end7 ], [ -1, %if.end12 ], [ -1, %if.end17 ]
  call void @llvm.lifetime.end(i64 800, i8* %0) #1
  ret i32 %retval.0
}

; Function Attrs: nounwind
declare void @llvm.lifetime.start(i64, i8* nocapture) #1

; Function Attrs: nounwind
declare i32 @printf(i8* nocapture, ...) #2

declare %struct.pb_Parameters* @pb_ReadParameters(i32*, i8**) #3

; Function Attrs: nounwind
declare noalias i8* @malloc(i64) #2

; Function Attrs: nounwind
declare noalias %struct._IO_FILE* @fopen(i8* nocapture, i8* nocapture) #2

; Function Attrs: nounwind
declare i32 @fclose(%struct._IO_FILE* nocapture) #2

declare void @pb_InitializeTimerSet(%struct.pb_TimerSet*) #3

declare void @pb_SwitchToTimer(%struct.pb_TimerSet*, i32) #3

declare void @llvm_visc_track_mem(i8*, i64) #3

; Function Attrs: nounwind
declare void @llvm.memcpy.p0i8.p0i8.i64(i8* nocapture, i8* nocapture, i64, i32, i1) #1

declare void @llvm_visc_request_mem(i8*, i64) #3

declare void @llvm_visc_untrack_mem(i8*) #3

declare void @pb_PrintTimerSet(%struct.pb_TimerSet*) #3

declare void @outputData(i8*, float*, i32, i32, i32) #3

; Function Attrs: nounwind
declare void @free(i8* nocapture) #2

declare void @pb_FreeParameters(%struct.pb_Parameters*) #3

; Function Attrs: nounwind
declare void @llvm.lifetime.end(i64, i8* nocapture) #1

; Function Attrs: nounwind
declare i64 @fread(i8* nocapture, i64, i64, %struct._IO_FILE* nocapture) #2

; Function Attrs: nounwind
declare i64 @strtol(i8*, i8** nocapture, i32) #2

; Function Attrs: nounwind
declare i32 @puts(i8* nocapture) #1

declare i8* @llvm_visc_initializeTimerSet()

declare void @llvm_visc_switchToTimer(i8**, i32)

declare void @llvm_visc_printTimerSet(i8**, i8*)

; Function Attrs: nounwind
declare void @llvm.visc.init() #1

; Function Attrs: nounwind
declare i8* @llvm.visc.getNode() #1

; Function Attrs: nounwind
declare i8* @llvm.visc.getParentNode(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNodeInstanceID.x(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNumNodeInstances.x(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNodeInstanceID.y(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNumNodeInstances.y(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNodeInstanceID.z(i8*) #1

; Function Attrs: nounwind
declare i32 @llvm.visc.getNumNodeInstances.z(i8*) #1

; Function Attrs: nounwind uwtable
define %rtype @naive_kernelInternal_level1(float %c0, float %c1, float* in %A0, i64 %bytes_A0, float* in out %Anext, i64 %bytes_Anext, i32 %nx, i32 %ny, i32 %nz, i32 %dimX, i32 %dimY, i32 %dimZ) #0 {
entry:
  %naive_kernel.node = call i8* @llvm.visc.createNode3D(i8* bitcast (%rtype (float, float, float*, i64, float*, i64, i32, i32, i32)* @naive_kernel to i8*), i32 %dimX, i32 %dimY, i32 %dimZ)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 0, i32 0)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 1, i32 1)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 2, i32 2)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 3, i32 3)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 4, i32 4)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 5, i32 5)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 6, i32 6)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 7, i32 7)
  call void @llvm.visc.bind.input(i8* %naive_kernel.node, i32 8, i32 8)
  ret %rtype undef
}

; Function Attrs: nounwind
declare i8* @llvm.visc.createNode3D(i8*, i32, i32, i32) #1

; Function Attrs: nounwind
declare void @llvm.visc.bind.input(i8*, i32, i32) #1

; Function Attrs: nounwind uwtable
define %rtype @naive_kernelInternal_level2(float %c0, float %c1, float* in %A0, i64 %bytes_A0, float* in out %Anext, i64 %bytes_Anext, i32 %nx, i32 %ny, i32 %nz, i32 %dimX, i32 %dimY, i32 %dimZ, i32 %dimX1, i32 %dimY2, i32 %dimZ3) #0 {
entry:
  %naive_kernelInternal_level1.node = call i8* @llvm.visc.createNode3D(i8* bitcast (%rtype (float, float, float*, i64, float*, i64, i32, i32, i32, i32, i32, i32)* @naive_kernelInternal_level1 to i8*), i32 %dimX1, i32 %dimY2, i32 %dimZ3)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 0, i32 0)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 1, i32 1)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 2, i32 2)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 3, i32 3)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 4, i32 4)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 5, i32 5)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 6, i32 6)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 7, i32 7)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 8, i32 8)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 9, i32 9)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 10, i32 10)
  call void @llvm.visc.bind.input(i8* %naive_kernelInternal_level1.node, i32 11, i32 11)
  ret %rtype undef
}

; Function Attrs: nounwind
declare i8* @llvm.visc.launch(i8*, i8*) #1

; Function Attrs: nounwind
declare void @llvm.visc.wait(i8*) #1

; Function Attrs: nounwind
declare void @llvm.visc.cleanup() #1

attributes #0 = { nounwind uwtable "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="true" "no-nans-fp-math"="true" "unsafe-fp-math"="true" "use-soft-float"="false" }
attributes #1 = { nounwind }
attributes #2 = { nounwind "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="true" "no-nans-fp-math"="true" "unsafe-fp-math"="true" "use-soft-float"="false" }
attributes #3 = { "less-precise-fpmad"="false" "no-frame-pointer-elim"="false" "no-frame-pointer-elim-non-leaf"="false" "no-infs-fp-math"="true" "no-nans-fp-math"="true" "unsafe-fp-math"="true" "use-soft-float"="false" }

!visc_hint_gpu = !{}
!visc_hint_cpu = !{!0, !1}

!0 = metadata !{%rtype (float, float, float*, i64, float*, i64, i32, i32, i32, i32, i32, i32)* @naive_kernelInternal_level1}
!1 = metadata !{%rtype (float, float, float*, i64, float*, i64, i32, i32, i32, i32, i32, i32, i32, i32, i32)* @naive_kernelInternal_level2}
!2 = metadata !{metadata !"float", metadata !3}
!3 = metadata !{metadata !"omnipotent char", metadata !4}
!4 = metadata !{metadata !"Simple C/C++ TBAA"}
!5 = metadata !{metadata !"int", metadata !3}
!6 = metadata !{metadata !"any pointer", metadata !3}
